<script setup>
    const config = useRuntimeConfig()

    import { ExistingCategory, Category } from '~/adapters/category.js';
    import { category_manager } from '~/adapters/category_manager.js';
    import { useSetDangerBackground, useClickOutsideEventListener } from '~/composables/graphics.js';
    import { capitalize } from 'vue';

    const emit = defineEmits(["close"]);

    onMounted(() => {
        useClickOutsideEventListener("form_categories", () => {emit("close", true)});
    });

    const new_category_name_bg = ref("bg-white");
    const class_choose_parent_category = ref("");


    /* Fetch categories from databases and filter major categories
     * Returns
     *     categories: all the categories
     *     major_categories: only the major categories (i.e. the ones which have no parent category)
     */
    async function fetchCategories() {
        const { data: categories, pending } = await useFetch(`${config.public.apiUrl}/categories`);
        const major_categories = retrieveMajorCategories(categories.value);
        return {
            categories: categories, 
            major_categories: major_categories
        };
    }

    function retrieveMajorCategories(list) {
        const major_categories = ref([]);
        if(list != null) {
            list.forEach(category => {
                if(category.parent == null) {
                    major_categories.value.push(new ExistingCategory(category.name, category.uid, category.parent));
                }
            });
        }
        return major_categories;
    }

    const {categories, major_categories} = await fetchCategories();

    const tailleCategorie=10;    
    const tailleElement=30;

    function removeExistingCategory(category) {
        category_manager.removeByObject(new ExistingCategory(category.name, category.uid, category.parent));
    }

    function registerExistingCategory(category) {
        category_manager.register(new ExistingCategory(category.name, category.uid, category.parent));
        //emit('close', true);
    }

    function registerNewCategory() {
        const dom_category_name = document.getElementById("id_new_category");
        if(dom_category_name.value.trim() == "") {
            new_category_name_bg.value = useSetDangerBackground();
        }
        else if (getMajorCategory() == null) {
            class_choose_parent_category.value = "font-bold text-red-500";
        }
        else {
            const new_category = new Category(capitalize(dom_category_name.value.trim()));
            new_category.parent = getMajorCategory();
            // TODO regex to force format of category name
            category_manager.register(new_category);
            dom_category_name.value = "";
            new_category_name_bg.value = "bg-white";
            class_choose_parent_category.value = "";
            resetMajorCategory();
            emit('close', true);
        }
    }

    function toggleAddNewCategory(checked) {
        const new_cat_div = document.getElementById("id_add_new_category");
        if(checked) {
            new_cat_div.setAttribute("class", new_cat_div.getAttribute("class").replace("hidden", ""));
        }
        else {
            new_cat_div.setAttribute("class", new_cat_div.getAttribute("class") + " hidden");
        }
    }

    function getMajorCategory() {
        let major_category = null;
        major_categories.value.forEach(category => {
            if(category.isMain()) {
                major_category = category;
            }
        })
        return major_category;
    }

    function setMajorCategory(target_index) {
        major_categories.value.forEach((category, index) => {
            if(index != target_index) {
                category.setIsMain(false);
            }
            else {
                class_choose_parent_category.value = "";
                category.setIsMain(!category.isMain());
            }
        });
    }

    function resetMajorCategory() {
        major_categories.value.forEach((category, index) => {
            category.setIsMain(false);
        });
    }

</script>

<template>
    <div class="w-full flex flex-col space-y-2 pb-2 bg-white z-10">
        <!-- Categories search list -->
        <FormSearchList
            :list=categories
            :selected=category_manager.getNameList()
            :tailleElement="tailleElement"
            @add="(element) => registerExistingCategory(element)"
            @remove="(element) => removeExistingCategory(element)" 
        />
        <!-- Add new category -->
        <FormCheckbox
            :id="'checkbox_new_category'"
            @checked="(checked) => toggleAddNewCategory(checked)"
            :text="'Tu ne trouves pas ta catégorie ?'"
            class="mx-2 text-sm"
        />
        <div id="id_add_new_category" class="flex flex-col space-y-2 m-2 hidden">
            <input
                id="id_new_category"
                type="text" 
                placeholder="Nomme ta propre catégorie"
                maxlength="100"
                :class="`p-2 rounded-lg shadow-las ${new_category_name_bg}`" 
                @keyup.enter="registerNewCategory"
            >
            <div class="flex flex-col space-y-2 text-center">
                <span :class="class_choose_parent_category">Choisis-lui une catégorie parente</span>
                <div class="flex flex-wrap">
                    <ButtonRemovable v-for="(major_cat, index) in major_categories" v-bind="major_cat" @click="setMajorCategory(index)" :taille="tailleCategorie" class="mr-2 mb-2"/>
                </div>
            </div>
            <ButtonAction :action-text="'Ajouter catégorie'" :action-click="registerNewCategory" />
        </div>
    </div>
</template>